from hwtLib.peripheral.usb.constants import USB_VER

USBIP_REQUEST = 0x8000
USBIP_REPLY = 0x0000

USBIP_OP_UNSPEC = 0x00
USBIP_OP_DEVINFO = 0x02
USBIP_OP_IMPORT = 0x03
USBIP_OP_EXPORT = 0x06
USBIP_OP_UNEXPORT = 0x07
USBIP_OP_DEVLIST = 0x05

USBIP_CMD_SUBMIT = 0x0001
USBIP_CMD_UNLINK = 0x0002
USBIP_RET_SUBMIT = 0x0003
USBIP_RET_UNLINK = 0x0004
USBIP_RESET_DEV = 0xFFFF

USBIP_ST_OK = 0x00
USBIP_ST_NA = 0x01

USBIP_BUS_ID_SIZE = 32
USBIP_DEV_PATH_MAX = 256

USBIP_VERSION = 0x0111

USBIP_SPEED_UNKNOWN = 0
USBIP_SPEED_VARIABLE = 4
USBIP_SPEED = {
    None: USBIP_SPEED_UNKNOWN,
    USB_VER.USB1_0: 1,
    USB_VER.USB1_1: 2,
    USB_VER.USB2_0: 3,
    USB_VER.USB3_0: 3,
}


USB_ENOENT = 2
USB_EPIPE = 32
